"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class RareDiseaseExitQuestionnaire(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "eventDate",
        "familyLevelQuestions",
        "reporter",
        "variantGroupLevelQuestions",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "familyLevelQuestions": reports_4_0_0.FamilyLevelQuestions,
            "variantGroupLevelQuestions": reports_4_0_0.VariantGroupLevelQuestions,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_4_0_0 import reports as reports_4_0_0

        return {
            "org.gel.models.report.avro.FamilyLevelQuestions": reports_4_0_0.FamilyLevelQuestions,
            "org.gel.models.report.avro.VariantGroupLevelQuestions": reports_4_0_0.VariantGroupLevelQuestions,
            "org.gel.models.report.avro.RareDiseaseExitQuestionnaire": reports_4_0_0.RareDiseaseExitQuestionnaire,
        }

    __slots__ = [
        "eventDate",
        "familyLevelQuestions",
        "reporter",
        "variantGroupLevelQuestions",
    ]

    def __init__(
        self,
        eventDate,
        familyLevelQuestions,
        reporter,
        variantGroupLevelQuestions,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_0_0.RareDiseaseExitQuestionnaire model.

        :param eventDate:
        :type eventDate: str
        :param familyLevelQuestions:
        :type familyLevelQuestions: FamilyLevelQuestions
        :param reporter:
        :type reporter: str
        :param variantGroupLevelQuestions:
        :type variantGroupLevelQuestions: list[VariantGroupLevelQuestions]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.0.0"
